;program wacznka zmierzchowych swiate do samochodu


;po wlaczeniu jesli in_prog = 0 oczekuje na kalibracje
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;programowanie - wersja z czasem T1 (opoznienie na odpalenie silnika):
;
; 1. za zwor prog i zwor Z
; 2. przycisnij przycisk prog
; 3. wczy zasilanie
; 4. odczekac czas zwloki T1 od pojawenia zasilania do obserwacji zmierzchu
; 5. po upywie czasu T1 pusc klawisz prog -
; 6. czas T1 zapisany do pamici - potwierdzne 1 blyskiem swiatel
; 7. jedno nacisniecie klawisza zapisuje poziom zmroku zapalajacego swiatla
; 8. poziom zmroku zapisany do pamieci - potwierdzne 2 blyskami swiatel
; 9. nacisnac klawisz i trzymac tak dlugo jaki ma byc czas zwloki T2 - ignorancji jasnosci
; 10. puscic klawisz czs T2 zapisany do pamieci - potwierdzne 3 blyskami swiatel
; 11. sciagnicie zwory prog -  poziom jasnosci swiatla gaszace swiatla
; 12. poziom jasnosci zapisany do pamieci - potwierdzne 4 blyskami swiatel
;*****************************************************************************
; programowanie jasnosci gaszacej swiatela - po czasie 

; a. zalozyc zwore PROG
; b. wlacz zasilanie
; c. jesli jest na tyle jasno aby wylaczy swiatlo sciagnij zwore
;******************************************************************************
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;programowanie - wersja z pomiarem napiecia zasilania
; 1. za zwor prog i zdejmij zwor Z
; 2. wykonac czynnosci z powyzszych punktow 1-12
; 3. nacisnac klawisz i trzymac tak dlugo jaki ma byc czas T3 podtrzymania swiatel "follow me home"
; 4. puscic klawisz - czs T3 zapisany do pamieci - potwierdzne 5 blyskami swiatel


;ostatnie dwa bajty pam. (kalibracja) 54h, 34h
;obsluga timera timer0 - zmiana bitu LED
;bez preskalera
; ze wstepnym ustawieniem licznika na wartosc 206
;odlicza 50 cyki maszynowych (fosc/4)i zienia stan led

;definiowanie zmiennych
#define ADC GPIO, 0			;wejscie przetwornika ADC
#define POM_U GPIO, 1		;wejscie pomiaru napicia
#define prog_key GPIO, 2		;wejscie klawisza programowania 
#define prog_z GPIO, 4		;wejscie zwory programowania 
#define px GPIO, 5			;wyjscie steujace przekaxnikiem
#define dph 20h				;starszy bajt pomocniczy
#define dpl 21h				;mlodszy bajt pomocniczy
#define licznik h'22'			;pomocniczy licznik petli opoznienia
#define data_rd h'23'			;przepisanie danej z eeprom
#define stos h'24'				;pomocniczy rejestr zapamietujacy zmienne jak stos
#define time_delay h'25'			;czas niekiego stanu na lampach
;********************************************************************************************************
;                     NAPIECIE PRZED I PO ODPALENIU SILNIKA
;
#define U_HI .208					;napicie po odpaleniu stacyjiki 208 = 13V, 1bit=0,0625V
#define U_LO .203					;napiecie po zgaszeniu silnika cb = 12,7V 1bit = 0,625V
;********************************************************************************************************
;deklaracj typu procesora i formatu liczb
	list p=12F675			;okreslenie typu procesora
	#include p12f675.inc	;dolaczenie pliku z nazwami

;konfiguracja procesora
	__config _INTRC_OSC_NOCLKOUT &_MCLRE_ON &_WDT_OFF; gen wew. RC bez wyjscia 
									;wlaczone wejscie reset
									;watch dog wylaczony
	org 0
	goto start
	
	org 4
	goto timer_int	; (2CM)
start

;wylacz komparator
	movlw .7
	movwf cmcon

;konfiguracja linii i/o
	bsf status, rp0;bank1

	movlw h'1f'					;0001 1111   0=wyjscie, 1=wejscie
	movwf trisio
	movlw h'3f'					;rezystor pull up na GP4 i 5 (31)
	movwf wpu
	bcf option_reg, 7				;zalacza wybrane w wpu rezystory do Vdd
							;GPPU=0 w rej option_reg 7 bit zalacza rezustory z rej. wpu
	bcf status, rp0 ;bank0

;wylacz adc
	;konfiguracja wejscia
	bsf status, rp0 ;bank1
	movlw b'11110001'	;	czestotliwo tj. RC, wejcie ANS1
	movwf ansel

	bcf status, rp0 ;bank0

	movlw b'00110001'	;	just - lewo; Vref=Vdd; ch0; ADC on
	movwf adcon0

;********************************************************
;program glowy
;********************************************************
	bcf px		;zgas swiatla 
	call delay1s	;odczekaj 1sec
	btfss prog_z	; jesli prog zwora 1 => omin nastepna instr,
	call prog_mem	;wywolanie funkcji programowania
;#################################################################
	btfsc POM_U		;czy zalozona zwora Z
	goto menu4
	;goto eeprom_test
	movlw h'03'		;w:=3 dres
	call eeprom_read	;
	movwf time_delay	; czas 
;opoznienie dzialania eeprom(00h)x sec
;czas T1=od waczenia U do oserwacji naslonecznienia
	clrw			;w:=0 dres
	call eeprom_read
	movwf data_rd
	call delay1s
	decfsz data_rd, f
	goto $-2
;***************************************
menu0
	movlw h'01'		;w:=1 dres
	call eeprom_read	;odczyt z pamieci progu zmierzchu do zapalenia swiatel
	movwf data_rd
menu1
	call delay10
	call ADC_converter	;odczyt ADC
	movf ADRESH, 0		; zapis ADC do W
	subwf	data_rd, 0		; czy jest ciemniej niz prog zmierzchu
	btfsc status, c
	goto menu1
	bsf px		;wlacz swiata
menu2
	movlw h'02'		;w:=2 dres
	call eeprom_read	;odczyt z pamieci progu jasnosci do gaszenia swiatel
	movwf data_rd
menu3
	call delay10
	call ADC_converter	;odczyt ADC
	movf ADRESH, 0		; zapis ADC do W
	subwf	data_rd, 0		; czy jest ciemniej niz prog zmierzchu
	btfss status, c
	goto menu3
	movlw h'03'		;w:=3 dres
	call eeprom_read	;odczyt z czasu zwloki do zapalania T2
	movwf data_rd
	call delay1s
	decfsz data_rd, f
	goto $-2
	movlw h'02'		;w:=2 dres
	call eeprom_read	;odczyt z pamieci progu jasnosci do gaszenia swiatel
	movwf data_rd
	call delay10
	call ADC_converter	;odczyt ADC
	movf ADRESH, 0		; zapis ADC do W
	subwf	data_rd, 0		; czy jest ciemniej niz prog zmierzchu
	btfss status, c
	goto menu3
	bcf px		;wylacz swiata
	goto menu0
;***************************************
;wresja z pomiarem napiecia zasilania
menu4
;wylacz adc
	;konfiguracja wejscia
	bsf status, rp0 ;bank1
	movlw b'11110011'	;	czestotliwo tj. RC, wejcie ANS1
	movwf ansel

	bcf status, rp0 ;bank0

	movlw b'00110001'	;	just - lewo; Vref=Vdd; ch0; ADC on
	movwf adcon0
menu5
	call delay10
	call ADC_U	;pomiar napiecia zasilania
	movlw U_HI 			;h'd0'13V 
	movwf data_rd
	movf ADRESH, 0		; zapis ADC do W
	subwf	data_rd, 0		; czy jest ciemniej niz prog zmierzchu
	btfss status, c
	goto menu6
	bcf px
	goto menu5
menu6					;silnik uruchomiony U>13,3V
	movlw h'01'		;w:=1 dres
	call eeprom_read	;odczyt z pamieci progu zmierzchu do zapalenia swiatel
	movwf data_rd
	call delay10
	call ADC_converter	;odczyt ADC
	movf ADRESH, 0		; zapis ADC do W
	subwf	data_rd, 0		; czy jest ciemniej niz prog zmierzchu
	btfsc status, c
	goto menu5
	bsf px		;wlacz swiata
menu7
	call delay10
	call ADC_U	;pomiar napiecia zasilania
	movlw U_LO			;h'cb' 12,7V    
	movwf data_rd
	movf ADRESH, 0		; zapis ADC do W
	subwf	data_rd, 0		; czy jest ciemniej niz prog zmierzchu
	btfss status, c
	goto menu8
	goto menu9
menu8
	movlw h'02'		;w:=2 dres
	call eeprom_read	;odczyt z pamieci progu jasnosci do gaszenia swiatel
	movwf data_rd
	call delay10
	call ADC_converter	;odczyt ADC
	movf ADRESH, 0		; zapis ADC do W
	subwf	data_rd, 0		; czy jest ciemniej niz prog zmierzchu
	btfss status, c
	goto menu7
	movlw h'03'		;w:=3 dres
	call eeprom_read	;odczyt z czasu zwloki do zapalania T2
	movwf data_rd
	call delay1s
	decfsz data_rd, f
	goto $-2
	movlw h'02'		;w:=2 dres
	call eeprom_read	;odczyt z pamieci progu jasnosci do gaszenia swiatel
	movwf data_rd
	call delay10
	call ADC_converter	;odczyt ADC
	movf ADRESH, 0		; zapis ADC do W
	subwf	data_rd, 0		; czy jest ciemniej niz prog zmierzchu
	btfss status, c
	goto menu7
	bcf px		;wylacz swiata
	goto menu5
menu9					;folow home

	movlw h'04'		;w:=3 dres
	call eeprom_read
	movwf data_rd
	call delay1s
	decfsz data_rd, f
	goto $-2
	bcf px
	goto menu5
;********************************************************
; funkcje pomocnicze
;obsluga przerwania od timera0
timer_int
	bcf intcon, t0if	;zeruje flage przerwania (1CM)
	bcf status, rp0	;bank0			(1CM)	
	movlw h'36'					;	(1CM)
	movwf tmr0	;	poczatkowa wartosc 204 + 2cykle na zaladowanie tmr0 (1CM)
	btfsc px; jesli led=0 omin next instr.	(1/2 CM)
	goto timer_int1					;(2CM)
	bsf px;	led bylo 0 => ustaw		;(1CM)
	goto timer_int_end				;(2CM)
timer_int1
	bcf px	;	ustawia led bo bylo 0	;(1CM)
timer_int_end
	retfie						;(2CM)

;fabryczna kalibracja generatora RC
;osc_cal
;	bsf status, rp0	;bank nr 1
;	call h'3ff'		;bobraie danych spd adr. 3ff do W
;	movwf osccal	;wyslanie danych z w o osccal
;	bcf status, rp0	;powrot do banku 0
;	return

;opoznienie o 100 us
delay_ux100
	movlw h'1c'		;1
delay_ux100b
	movwf dpl		;przepisuja W do dpl
	decfsz dpl,0	;1 dekrement, wynik do W, jesli 0 pomin next instr.
	goto delay_ux100b	;1
	return	


;opoznienie o 10 ms
delay10
	movlw h'0b'		;1 bylo 0bh
delay10a
	movwf dph		;1
	movlw h'f2'		;1
delay10b
	movwf dpl	;przepisuja W do dpl
	decfsz dpl,0		;1 dekrement, wynik do W, jesli 0 pomin next instr.
	goto delay10b	;1
	movlw dph	;	wpisz do W dph
	decfsz dph,0	;1 zmniejsz dph, wynik do W, jesli 0 pomin next instr.
	goto delay10a	;1
	return	

;opoznienie o 1 sek
delay1s
	movwf stos 	;zapamietuje W na stosie
	movlw .100
	movwf licznik
	call delay10
	decfsz licznik, f
	goto $-2
	movf stos,0	;oddaje wartosc W
	return

;blysk led co 1 sec
blink_led
	bsf px
	call delay1s
	bcf px
	call delay1s
	return
;odczyt z eeprom spod adr. W, dana zapisana do W
eeprom_read
	bsf status, rp0 ;bank1
	movwf eeadr		;wpisanie adresu z w eeadr
	bsf eecon1, rd	;odczyt z eeprom
	movf eedata, w	;przepisanie odczytanej danej do w
	bcf status, rp0 ;bank0
	return
;#########################################################################

;funkcja programowania pamieci eeprom
prog_mem
	btfsc prog_key
	goto prog_mem7
	movlw h'01'	;zapisanie do W 01H
	btfsc prog_key
	goto prog_mem2
prog_mem1
	call delay1s	;odczekaj 1sec
	btfsc prog_key	; jesli 2^0=1 przeskocz instr,
	goto prog_mem2
	movwf	f	;przejlij w do f
	incf	f, 0	;inc f i zapisz do W
	goto prog_mem1
prog_mem2
	movwf data_rd	;przepisanie dnych z W do DATA_RD
				;zapis nowych danych do eeprom pod adr. 0
	bsf status, rp0 ;bank1
	clrw			;w:=0 dres
	movwf eeadr		;wpisanie adresu z w eeadr
	movf data_rd, 0	;dane do zapisu wyslane do W
	movwf eedata	;wyslanie danych do eedata
	bsf eecon1, wren	;zezwolenie na zapis
	movlw h'55'
	movwf eecon2
	movlw h'aa'
	movwf eecon2
	bsf eecon1, wr	;rozpoczecie zapisu
	btfsc eecon1, wr	;oczekiwanie na koniec zapisu
	goto $-1
	bcf eecon1, wren	;wyl. zezwolenia na zapis
	bcf status, rp0	;powrot do bank0
;******************************************************************************
	call blink_lamp	;blyska swiatlami na 100ms
	call delay1s	;odczekaj 1sec
	call delay1s	;odczekaj 1sec
;******************************************************************************
prog_mem3			;programowanie progu zmierzchu
	btfsc prog_key
	goto prog_mem3
	call ADC_converter	;odczyt progu zmierzchu
	movf ADRESH, 0	;przeslij wynik konwersji do W
	movwf data_rd	;przepisanie dnych z W do DATA_RD
				;zapis nowych danych do eeprom pod adr. 0
	bsf status, rp0 ;bank1
	movlw h'01'		;w:=1 dres
	movwf eeadr		;wpisanie adresu z w eeadr
	movf data_rd, 0	;dane do zapisu wyslane do W
	movwf eedata	;wyslanie danych do eedata
	bsf eecon1, wren	;zezwolenie na zapis
	movlw h'55'
	movwf eecon2
	movlw h'aa'
	movwf eecon2
	bsf eecon1, wr	;rozpoczecie zapisu
	btfsc eecon1, wr	;oczekiwanie na koniec zapisu
	goto $-1
	bcf eecon1, wren	;wyl. zezwolenia na zapis
	bcf status, rp0	;powrot do bank0
;******************************************************************************
	call blink_lamp	;blyska swiatlami na 100ms
	call blink_lamp	;blyska swiatlami na 100ms
	call delay1s	;odczekaj 1sec
	call delay1s	;odczekaj 1sec
;*******************************************************************************
; programowanie czasu t2
prog_mem4
	btfsc prog_key
	goto prog_mem4
	call delay1s	;odczekaj 1sec
	movlw h'01'	;zapisanie do W 01H
prog_mem5
	call delay1s	;odczekaj 1sec
	btfsc prog_key	; jesli 2^1=2 przeskocz instr,
	goto prog_mem6
	movwf	f	;przejlij w do f
	incf	f, 0	;inc f i zapisz do W
	goto prog_mem5
prog_mem6
	movwf data_rd	;przepisanie dnych z W do DATA_RD
				;zapis nowych danych do eeprom pod adr. 0
	bsf status, rp0 ;bank1
	movlw h'03'		;w:=2 dres
	movwf eeadr		;wpisanie adresu z w eeadr
	movf data_rd, 0	;dane do zapisu wyslane do W
	movwf eedata	;wyslanie danych do eedata
	bsf eecon1, wren	;zezwolenie na zapis
	movlw h'55'
	movwf eecon2
	movlw h'aa'
	movwf eecon2
	bsf eecon1, wr	;rozpoczecie zapisu
	btfsc eecon1, wr	;oczekiwanie na koniec zapisu
	goto $-1
	bcf eecon1, wren	;wyl. zezwolenia na zapis
	bcf status, rp0	;powrot do bank0
;******************************************************************************
	call blink_lamp	;blyska swiatlami na 100ms
	call blink_lamp	;blyska swiatlami na 100ms
	call blink_lamp	;blyska swiatlami na 100ms
	call delay1s	;odczekaj 1sec
	call delay1s	;odczekaj 1sec
prog_mem7
	btfss prog_z
	goto prog_mem7
;****************************************************************************	
	call ADC_converter	;odczyt progu jasnosci - ktora gasi swiata
	movf ADRESH, 0	;przeslij wynik konwersji do W
	movwf data_rd	;przepisanie dnych z W do DATA_RD
				;zapis nowych danych do eeprom pod adr. 0
	bsf status, rp0 ;bank1
	movlw h'02'		;w:=2 dres
	movwf eeadr		;wpisanie adresu z w eeadr
	movf data_rd, 0	;dane do zapisu wyslane do W
	movwf eedata	;wyslanie danych do eedata
	bsf eecon1, wren	;zezwolenie na zapis
	movlw h'55'
	movwf eecon2
	movlw h'aa'
	movwf eecon2
	bsf eecon1, wr	;rozpoczecie zapisu
	btfsc eecon1, wr	;oczekiwanie na koniec zapisu
	goto $-1
	bcf eecon1, wren	;wyl. zezwolenia na zapis
	bcf status, rp0	;powrot do bank0
;*******************************************************************************
	call blink_lamp	;blyska swiatlami na 100ms
	call blink_lamp	;blyska swiatlami na 100ms
	call blink_lamp	;blyska swiatlami na 100ms
	call blink_lamp	;blyska swiatlami na 100ms
	
prog_mem8
	btfsc prog_key
	goto prog_mem8
	call delay1s	;odczekaj 1sec
	movlw h'01'	;zapisanie do W 01H
prog_mem9
	call delay1s	;odczekaj 1sec
	btfsc prog_key	; jesli 2^1=2 przeskocz instr,
	goto prog_mem9a
	movwf	f	;przejlij w do f
	incf	f, 0	;inc f i zapisz do W
	goto prog_mem9
prog_mem9a
	movwf data_rd	;przepisanie dnych z W do DATA_RD
				;zapis nowych danych do eeprom pod adr. 0
	bsf status, rp0 ;bank1
	movlw h'04'		;w:=4 dres
	movwf eeadr		;wpisanie adresu z w eeadr
	movf data_rd, 0	;dane do zapisu wyslane do W
	movwf eedata	;wyslanie danych do eedata
	bsf eecon1, wren	;zezwolenie na zapis
	movlw h'55'
	movwf eecon2
	movlw h'aa'
	movwf eecon2
	bsf eecon1, wr	;rozpoczecie zapisu
	btfsc eecon1, wr	;oczekiwanie na koniec zapisu
	goto $-1
	bcf eecon1, wren	;wyl. zezwolenia na zapis
	bcf status, rp0	;powrot do bank0
;******************************************************************************
	call blink_lamp	;blyska swiatlami na 100ms
	call blink_lamp	;blyska swiatlami na 100ms
	call blink_lamp	;blyska swiatlami na 100ms
	call blink_lamp	;blyska swiatlami na 100ms
	call blink_lamp	;blyska swiatlami na 100ms
	goto $
	return
;*************************************************************************************
;sprawdzenie zawartosci eeprom
;blyska led tyle razy ile zawartosc kom. adr. 00h
; pauza
;blyska led tyle razy ile zawartosc kom. adr. 01h
eeprom_test
	clrw			;w:=0 dres
	call eeprom_read
;wyswietlenie odczytanej danej
;blysniecie led x eeprom
	movwf data_rd
	call blink_led
	decfsz data_rd, f
	goto $-2
;pauza
	call delay1s
	bsf px
	call delay1s
	call delay1s
	call delay1s
	bcf px
	call delay1s
;2 komorka eeprom
	movlw h'01'	;zapisanie do W 01H adres
	call eeprom_read
;wyswietlenie odczytanej danej
;blysniecie led x eeprom
	movwf data_rd
	call blink_led
	decfsz data_rd, f
	goto $-2
	goto $
;*****************************************************
;bysnicie siatlami dlugimi
;100ms swiatla i 200ms ciemne
blink_lamp
	bsf px ;	wlacz swiatla dlugie
	movlw h'0a'		;W:=10
	movwf licznik		;przeslij W do licznik
blink_lamp1
	call delay10
	decfsz licznik,0		;1 dekrement, wynik do W, jesli 0 pomin next instr.
	goto blink_lamp2
	goto blink_lamp3
blink_lamp2
	movwf licznik		;przeslij W do licznik
	goto blink_lamp1
;minelo 10x 10ms
blink_lamp3

	bcf px ;	wylacz swiatla dlugie
	movlw h'14'		;W:=10
	movwf licznik		;przeslij W do licznik
blink_lamp4
	call delay10
	decfsz licznik,0		;1 dekrement, wynik do W, jesli 0 pomin next instr.
	goto blink_lamp5
	goto blink_lamp_end
blink_lamp5
	movwf licznik		;przeslij W do licznik
	goto blink_lamp4
;minelo 10x 10ms
blink_lamp_end
	return	

;przetwarzanie ADC
ADC_converter
	bcf status, rp0
	bcf adcon0, chs0	;kanal 0
	bcf adcon0, chs1
	call delay10us	;opoznienie na ustabilizowanie 
	bsf adcon0, go	; start konwersji ADC
	btfsc adcon0, go	; czy koniec konwersji
	goto $-1
	return
;opoznienie 10us
delay10us
	goto $+1
	goto $+1
	goto $+1
	return
;przetwarzanie ADC - pomiar U
ADC_U
	bcf status, rp0
	bsf adcon0, chs0	;kanal 1
	bcf adcon0, chs1
	call delay10us	;opoznienie na ustabilizowanie 
	bsf adcon0, go	; start konwersji ADC
	btfsc adcon0, go	; czy koniec konwersji
	goto $-1
	return

	end
